/*
 * PROJECTNAME
 *
 * Please read README in the Documentation group
 * for additional instructions.
 *
 */

#include <SDL/SDL.h>
#include <kos.h>
#include <stdio.h>

extern uint8 romdisk[];

KOS_INIT_FLAGS(INIT_DEFAULT);
KOS_INIT_ROMDISK(romdisk);     

SDL_Surface *screen;
		
int main (int argc, const char * argv[]) {
		SDL_Surface *bitmap=NULL; //A pointer to our bitmap image
		SDL_Rect pos; //The position of our bitmap
		int done=0,xv=4,yv=4;

		//Change into romdisk directory.  Change this to /cd when burning a CD.
		fs_chdir("/rd");
		
		//Intialize SDL
		if(SDL_Init(SDL_INIT_VIDEO)<0) {
			printf("Unable to initialze SDL\n");
			return 1;
		}
		
		//Set the video mode to 640x480, 16bpp
		screen=SDL_SetVideoMode(640,480,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
		
		if(screen==NULL) {
			printf("Unable to set video mode\n");
			return 1;
		}
		
		//Load a bitmap file
    bitmap = SDL_LoadBMP("hello.bmp");
		
		if(bitmap==NULL) {
			printf("Unable to open bitmap\n");
			return 1;
		}
		
		//Center the bitmap
		pos.x=320;
		pos.y=240;
		
		/* keep drawing frames until start is pressed */
    while(!done) {
				pos.x+=xv;
				pos.y+=yv;
				
				//Clear the screen
				SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,20,40,60)) ;
				SDL_BlitSurface(bitmap,NULL,screen,&pos);
				SDL_Flip(screen);
				
				//Make the image reverse direction if it bumps the edge of our rectangle
				if(pos.x>540 || pos.x < 100) xv *= -1;
				if(pos.y>380 || pos.y < 100) yv *= -1;
				
				//Loop through every controller and check for the Start button being pressed
        MAPLE_FOREACH_BEGIN(MAPLE_FUNC_CONTROLLER, cont_state_t, st)
            if (st->buttons & CONT_START)
                done = 1;
        MAPLE_FOREACH_END()
				
				//Delay for 10ms
				thd_sleep(10);
    }         
		return 0;
}
